package sppMain;

import java.io.*;
import java.text.*;
import java.util.*;
import javax.servlet.*;
import javax.servlet.http.*;

import java.sql.*;
import edu.yale.its.tp.cas.client.*;

import sppMain.*;
import htmlcreator.*;
import log.*;

/* 
 * Serwlet odpowiadający za logowanie i inicjalizację sesji.
 * @author Kotwasiński Adam
 */
public class Login extends HttpServlet {
	public void doGet(HttpServletRequest request, HttpServletResponse response) throws IOException, ServletException {
		request.setCharacterEncoding("UTF-8");
		response.setCharacterEncoding("UTF-8");
		response.setContentType("text/html");
		PrintWriter out = response.getWriter();
    HttpSession session = request.getSession(true);
    String userPESEL = session.getAttribute("edu.yale.its.tp.cas.client.filter.user").toString();
		Connection conn = DBHandler.connect();
    int uid = SPPMain.authorise(conn, userPESEL);
    session.setAttribute("userId", uid);
    String fullName = SPPMain.getFullName(conn, uid);
		if (fullName == null) 
			fullName = "Nieznany użytkownik";
    session.setAttribute("fullName", fullName);

		/* Sprawdzenie, czy w systemie (tabela Users) znajduje się dany użytkownik. */
    if (!SPPMain.validUID(conn, uid)) {
  		HtmlCreator.printNoAuthorizationPage(out, fullName);
      LogHandler.appendLog("login(no_CAS_data)" + uid + "," + fullName); 
			DBHandler.disconnect(conn);
      return;
    }

		HtmlCreator.printStartPage(out);
		HtmlCreator.printLoginBar(out, 1, fullName);

    boolean st = false, ex = false, ad = false;

    if (SPPMain.validStudent(conn, uid)) {
      session.setAttribute("userType", "student");
      HtmlCreator.printStudentMenu(out, null);
      LogHandler.appendLog("login(st):" + uid + "," + fullName); 
      st = true;
    }

    if (SPPMain.validExaminer(conn, uid)) {
      session.setAttribute("userType", "examiner");
      HtmlCreator.printTeacherMenu(out, null);
      LogHandler.appendLog("login(ex):" + uid + "," + fullName); 
      ex = true;
    }

    if (SPPMain.validAdmin(conn, uid)) {
      session.setAttribute("userType", "admin");
  		HtmlCreator.printAdminMenu(out, null);
      LogHandler.appendLog("login(ad):" + uid + "," + fullName); 
      ad = true;
    }

		/* Użytkownik znajduje się w systemie (tabela Users), ale nie ma żadnych uprawnień. */
    if ((!ex) && (!st) && (!ad)) {
      out.println(HtmlCreator.warningMessage("System SUBMIT++", "Błąd podczas logowania", "Nie masz żadnych uprawnień w systemie."));
      LogHandler.appendLog("login(no_capabilities):" + uid + "," + fullName); 
    }

		HtmlCreator.startMainTable(out);
		HtmlCreator.startLeftMenu(out);
		HtmlCreator.endLeftMenu(out);
    HtmlCreator.startMainTableContents(out, "");

    if (st) 
      out.println(HtmlCreator.helloMessage("Znajdujesz się w części systemu poświęconej studentom."));

    if (ex)
      out.println(HtmlCreator.helloMessage("Znajdujesz się w części systemu poświęconej pracownikom."));

    if (ad)
      out.println(HtmlCreator.helloMessage("Jesteś zalogowany jako administrator."));

  	HtmlCreator.printFootnote(out);
  	HtmlCreator.endMainTableContents(out);
  	HtmlCreator.endMainTable(out);
  	HtmlCreator.printEndPage(out);
		DBHandler.disconnect(conn);
  }
}
